##############################################################################
#
# This file is provided under a dual BSD/GPLv2 license.  When using or 
#   redistributing this file, you may do so under either license.
# 
#   GPL LICENSE SUMMARY
# 
#   Copyright(c) 2007,2008,2009,2010 Intel Corporation. All rights reserved.
# 
#   This program is free software; you can redistribute it and/or modify 
#   it under the terms of version 2 of the GNU General Public License as
#   published by the Free Software Foundation.
# 
#   This program is distributed in the hope that it will be useful, but 
#   WITHOUT ANY WARRANTY; without even the implied warranty of 
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
#   General Public License for more details.
# 
#   You should have received a copy of the GNU General Public License 
#   along with this program; if not, write to the Free Software 
#   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
#   The full GNU General Public License is included in this distribution 
#   in the file called LICENSE.GPL.
# 
#   Contact Information:
#   Intel Corporation
# 
#   BSD LICENSE 
# 
#   Copyright(c) 2007,2008,2009, 2010 Intel Corporation. All rights reserved.
#   All rights reserved.
# 
#   Redistribution and use in source and binary forms, with or without 
#   modification, are permitted provided that the following conditions 
#   are met:
# 
#     * Redistributions of source code must retain the above copyright 
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright 
#       notice, this list of conditions and the following disclaimer in 
#       the documentation and/or other materials provided with the 
#       distribution.
#     * Neither the name of Intel Corporation nor the names of its 
#       contributors may be used to endorse or promote products derived 
#       from this software without specific prior written permission.
# 
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# 
#  version: QAT_CRYPTO_DRIVER.L.0.1.0-14
#
##############################################################################

#-----------------------------------------------------------------------------


OS_LEVEL=user_space

SOFTCPM_DIR=${ICP_ROOT}/qat_sw_lib/sw
MK_DIR?=${SOFTCPM_DIR}/mk

SOFT_CPM		= ${ICP_ROOT}
QAT_DIR 		= ${SOFT_CPM}/qat_sw_lib/sw/qat


#External API

CPA_API_DIR?=${QAT_DIR}/include

DC_API_DIR=${CPA_API_DIR}/dc
PM_API_DIR=${CPA_API_DIR}/pm
CY_API_DIR=${CPA_API_DIR}/lac

COMMON_LIB_NAME = libqat_common_api
DC_LIB_NAME     = libqat_dc_api
PM_LIB_NAME     = libqat_pm_api
CY_LIB_NAME     = libqat_cy_api

#Common paths
IPP_DIR 		= ${SOFT_CPM}/qat_sw_lib/sw/ipp

NTL_DIR		    = ${SOFT_CPM}/qat_sw_lib/sw/ntl
QAT_USAGE_SAMPLES_DIR = ${QAT_DIR}/usage_samples


QAT_COMMON_DIR	= ${QAT_DIR}/src/common




QAT_CY_ROOT 	  = ${QAT_DIR}/src/cy
QAT_CY_COMMON 	  = ${QAT_CY_ROOT}/common
QAT_CY_SYM 		  = ${QAT_CY_ROOT}/sym
QAT_CY_SYM_COMMON = ${QAT_CY_ROOT}/sym
QAT_CY_ASYM 	  = ${QAT_CY_ROOT}/asym
QAT_CY_HASH 	  = ${QAT_CY_ROOT}/sym
QAT_CY_CIPHER 	  = ${QAT_CY_ROOT}/sym
QAT_CY_CHAIN 	  = ${QAT_CY_ROOT}/sym
QAT_CY_RSA 		  = ${QAT_CY_ROOT}/asym/rsa
QAT_CY_DH 		  = ${QAT_CY_ROOT}/asym/dh
QAT_CY_BIGNUM	  = ${QAT_CY_ROOT}/asym/bignum

LIB_ARCH=ia32
ifeq (${ARCH},em64t)
LIB_ARCH=em64t
endif

#Internal API
ASYNC_INC_DIR=${QAT_DIR}/include/

IPP_API_DIR=${IPP_DIR}/${LIB_ARCH}/include

CpaUsageIncDir = ${QAT_DIR}/usage_samples/include

