################################################################################
#
# This file is provided under a dual BSD/GPLv2 license.  When using or 
#   redistributing this file, you may do so under either license.
# 
#   GPL LICENSE SUMMARY
# 
#   Copyright(c) 2007,2008,2009,2010 Intel Corporation. All rights reserved.
# 
#   This program is free software; you can redistribute it and/or modify 
#   it under the terms of version 2 of the GNU General Public License as
#   published by the Free Software Foundation.
# 
#   This program is distributed in the hope that it will be useful, but 
#   WITHOUT ANY WARRANTY; without even the implied warranty of 
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
#   General Public License for more details.
# 
#   You should have received a copy of the GNU General Public License 
#   along with this program; if not, write to the Free Software 
#   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
#   The full GNU General Public License is included in this distribution 
#   in the file called LICENSE.GPL.
# 
#   Contact Information:
#   Intel Corporation
# 
#   BSD LICENSE 
# 
#   Copyright(c) 2007,2008,2009, 2010 Intel Corporation. All rights reserved.
#   All rights reserved.
# 
#   Redistribution and use in source and binary forms, with or without 
#   modification, are permitted provided that the following conditions 
#   are met:
# 
#     * Redistributions of source code must retain the above copyright 
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright 
#       notice, this list of conditions and the following disclaimer in 
#       the documentation and/or other materials provided with the 
#       distribution.
#     * Neither the name of Intel Corporation nor the names of its 
#       contributors may be used to endorse or promote products derived 
#       from this software without specific prior written permission.
# 
#   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
#   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
#   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
#   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
#   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
#   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
#   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
#   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
#   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# 
#  version: QAT_CRYPTO_DRIVER.L.0.1.0-14
#
###############################################################################


##
###############################################################################
# @file  .../mk/toolchain.mk
#
# The Make instructions below are for setting up the toolchain-chosen for
# the common rules applicable to the overall compilation. 
# The rules specific for submodules should be added to the specific 
# sub-module's Makefile.
##############################################################################/

AR  ?= /opt/intel/Compiler/11.1/046/bin/${LIB_ARCH}/xiar
LD  ?= /opt/intel/Compiler/11.1/046/bin/${LIB_ARCH}/xild
CC  ?= /opt/intel/Compiler/11.1/046/bin/${LIB_ARCH}/icc
CXX ?= /opt/intel/Compiler/11.1/046/bin/${LIB_ARCH}/icc
ASM ?= /nfs/site/local/software/tools/bin/yasm 

# Configure the CFLAGS according to the selected compiler
#
ICC_CFLAGS += -O3 -fPIC -xHost -ipo -D__INTEL_COMPILER -no-prec-div -D_GNU_SOURCE -Wall
GCC_CFLAGS += -O3 -msse -msse2 -msse3 -msse4.1 -msse4.2 -maes -Wall

###Toolchain's interative looped symbols' resolution switches
TOOLCHAIN_START_GROUP = -Wl,--start-group
TOOLCHAIN_END_GROUP   = -Wl,--end-group

RSA_64BIT_CFLAGS = -DLINUX64 
ifeq (${ARCH},ia32)
GCC_CFLAGS += -m32
GCC_CFLAGS += -DLINUX32
ICC_CFLAGS += -DLINUX32
else
GCC_CFLAGS += ${RSA_64BIT_CFLAGS} -fPIC
ICC_CFLAGS += ${RSA_64BIT_CFLAGS}
endif

GCC_CFLAGS += -DKASUMI_ENABLED
ICC_CFLAGS += -DKASUMI_ENABLED

ifeq ("$(CFLAGS)","")
ifeq (icc, $(findstring icc, ${CC}))
CFLAGS += $(ICC_CFLAGS)
else
CFLAGS += $(GCC_CFLAGS)
endif
endif

# Fully Static Link
STATIC_LDFLAGS=-static -static-libgcc
STATIC_LIBPATH=-L/usr/lib64
STATIC_LIBS=-lpthread -lc


#Toolchain variables available in .../Core/ia.mk
COMPILER=${CC}
LINKER=${LD}
ARCHIVER=${AR}


export COMPILER
export LINKER
export ARCHIVER

SHOWVAR-%:
	@echo "$@ = $($*)"

