/***************************************************************************
 *
 * GPL LICENSE SUMMARY
 * 
 *   Copyright(c) 2007,2008,2009,2010 Intel Corporation. All rights reserved.
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of version 2 of the GNU General Public License as
 *   published by the Free Software Foundation.
 * 
 *   This program is distributed in the hope that it will be useful, but 
 *   WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 *   General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License 
 *   along with this program; if not, write to the Free Software 
 *   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *   The full GNU General Public License is included in this distribution 
 *   in the file called LICENSE.GPL.
 * 
 *   Contact Information:
 *   Intel Corporation
 * 
 *  version: QAT_CRYPTO_DRIVER.L.0.1.0-14
 *
 ***************************************************************************/
 /*
 * icp_aes_gcm.h
 * Prototypes of the functions needed for AES_GCM
 * 
 */
#ifndef ICP_AES_GCM_H
#define ICP_AES_GCM_H

#include <linux/module.h>
#include <linux/types.h>
#include <linux/crypto.h>

#include "cpa.h"

/* all sizes are in bytes*/
#define AES_GCM_IV_SIZE      (8)
#define GCM_SALT_LEN         (4)
#define LAC_IV_LEN           (16)
#define AES_GCM_AUTH_TAG_LEN (16)

int encrypt_aes_gcm(struct aead_request *pReq);
int decrypt_aes_gcm(struct aead_request *pReq);
int geniv_encrypt_aes_gcm(struct aead_givcrypt_request *pReq);
int geniv_decrypt_aes_gcm(struct aead_givcrypt_request *pReq);
int setkey_aes_gcm(struct crypto_aead *pAead, const Cpa8U *pKey, unsigned int key_len);


#endif
