/***************************************************************************
 *
 * GPL LICENSE SUMMARY
 * 
 *   Copyright(c) 2007,2008,2009,2010 Intel Corporation. All rights reserved.
 * 
 *   This program is free software; you can redistribute it and/or modify 
 *   it under the terms of version 2 of the GNU General Public License as
 *   published by the Free Software Foundation.
 * 
 *   This program is distributed in the hope that it will be useful, but 
 *   WITHOUT ANY WARRANTY; without even the implied warranty of 
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
 *   General Public License for more details.
 * 
 *   You should have received a copy of the GNU General Public License 
 *   along with this program; if not, write to the Free Software 
 *   Foundation, Inc., 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *   The full GNU General Public License is included in this distribution 
 *   in the file called LICENSE.GPL.
 * 
 *   Contact Information:
 *   Intel Corporation
 * 
 *  version: QAT_CRYPTO_DRIVER.L.0.1.0-14
 *
 ***************************************************************************/
 
 /*
 * icp_sym_chaining
 * Prototypes of the functions needed for AES_CBC_HMAC_SHA1 and 3DES_HMAC_SHA1
 * 
 */
#ifndef ICP_SYM_CHAINING_H
#define ICP_SYM_CHAINING_H


#include <linux/types.h>
#include <linux/errno.h>
#include <linux/crypto.h>

#include "cpa.h"

/* all the sizes are in bytes*/
#define AES_BLOCK_SIZE  (16)
#define AES_IV_LEN      (16)

#define DES3_BLOCK_SIZE  (8)
#define DES3_IV_LEN      (8)

#define SHA1_DIGEST_SIZE (20)

int encrypt_aes_cbc_hmac_sha1(struct aead_request *pReq);
int decrypt_aes_cbc_hmac_sha1(struct aead_request *pReq);
int geniv_encrypt_aes_cbc_hmac_sha1(struct aead_givcrypt_request *pReq);
int geniv_decrypt_aes_cbc_hmac_sha1(struct aead_givcrypt_request *pReq);
int setkey_aes_cbc_hmac_sha1(struct crypto_aead *pAead, const Cpa8U *pKey, unsigned int key_len);

int encrypt_3des_hmac_sha1(struct aead_request *pReq);
int decrypt_3des_hmac_sha1(struct aead_request *pReq);
int geniv_encrypt_3des_hmac_sha1(struct aead_givcrypt_request *pReq);
int geniv_decrypt_3des_hmac_sha1(struct aead_givcrypt_request *pReq);
int setkey_3des_hmac_sha1(struct crypto_aead *pAead, const Cpa8U *pKey, unsigned int key_len);

#endif
